/*!
 * @file        main.c
 *
 * @brief       Main program body
 *
 * @version     V1.0.1
 *
 * @date        2025-04-31
 *
 * @attention
 *
 *  Copyright (C) 2026 Geehy Semiconductor
 *
 *  You may not use this file except in compliance with the
 *  GEEHY COPYRIGHT NOTICE (Geehy Semiconductor Software License Agreement).
 *
 *  The program is only for reference, which is distributed in the hope
 *  that it will be useful and instructional for customers to develop
 *  their software. Unless required by applicable law or agreed to in
 *  writing, the program is distributed on an "AS IS" BASIS, WITHOUT
 *  ANY WARRANTY OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the Geehy Semiconductor Software License Agreement for the governing permissions
 *  and limitations under the License.
 */

/* Includes */
#include "stdio.h"

#include "CDD_Usart.h"
#include "Mcu.h"
#include "Port.h"

#define TX_LEN 10
#define RX_LEN 10
#define TX_CHAR 50

#define ARRAY_SIZE(arr) (sizeof(arr) / sizeof((arr)[0]))
	
uint8 txData[8] = {0x85,0x95,0xA4,0xB0,0xC3,0xD1,0xE6,0xF2};
uint8 txData1[1] = {0x55};

uint16 rxData[10] = {0};

char txChar[TX_CHAR] = "HELLO APM TINY BOARD";
  
  
  


void delay(volatile uint32 value)
{
    while(value--);
}

/*!
 * @brief       Main program
 *
 * @param       None
 *
 * @retval      None
 *
 * @note
 */
int main(void)
{
    int flag = 0;

	Mcu_Init(&g_mcuConfig);
    Mcu_InitClock(McuClockSettingConfig_0);
    Port_Init(&g_portConfig);
	Usart_Init(g_usartConfg);
    
    NVIC_EnableIRQ(USART2_IRQn);
    NVIC_EnableIRQ(USART1_IRQn);
    
    Usart_RxData(USART1_ID,rxData,8);
    if (STATUS_USART_SUCCESS == Usart_TxData(USART2_ID,txData,8))
    {
        delay(50000);
        for (int i = 0; i < 8; i++)
        {
            if (txData[i] != rxData[i])
            {
                flag = 1;
            }
        }
    }
    
    if (flag == 0)
    {
        printf("Communication interrupted successfully, data is correct.\r\n");
    }
    else
    {
        printf("Communication interrupted error.\r\n");
    }
    
    flag = 0;
    while(1)
    {
        
    }
}

#if defined (__CC_ARM) || defined (__ICCARM__) || (defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 6010050))

/*!
* @brief       Redirect C Library function printf to serial port.
*              After Redirection, you can use printf function.
*
* @param       ch:  The characters that need to be send.
*
* @param       *f:  pointer to a FILE that can recording all information
*              needed to control a stream
*
* @retval      The characters that need to be send.
*
* @note
*/
int fputc(int ch, FILE* f)
{
    int reVal = 0;
    reVal = Usart_PutRedefinition(USART1_ID,&ch);
    
    return reVal;
}

/* If configuring the full library using versions after IAR 9.30,
   it is necessary to implement the _write function for printf redirection.*/
size_t __write(int handle,const unsigned char *buf,size_t bufSize)
{
    int32 tempCh = 0;
    for(int i=0; i<bufSize; i++)
    {
        Usart_PutRedefinition(USART1_ID,&tempCh);
    }
    return bufSize;
}

#elif defined (__GNUC__)

/* For Arm Cross GCC: Eclipse */
int _write(int fd,const unsigned char *buf,int len)
{
    int32 tempCh = 0;
    for(int i=0; i<len; i++)
    {
        int32 tempCh = (int32)buf[i];
        Usart_PutRedefinition(USART1_ID,&tempCh);
    }
    return len;
}

#endif
/**@} end of group Template_Functions */
/**@} end of group Template */
/**@} end of group Examples */
